clear all
close all
clc

load sleep75.mat;

%Obs:    706

data = sleep75;

%   1. age                      in years
%   2. black                    =1 if black
%   3. ccase                     identifier
%   4. clerical                 =1 if clerical worker
%   5. construc                 =1 if construction worker
%   6. educ                     years of schooling
%   7. earns74                  total earnings, 1974
%   8. gdhlth                   =1 if in good or excellent health
%   9. inlf                     =1 if in labor force
%  10. leis1                    sleep - totwrk
%  11. leis2                    slpnaps - totwrk
%  12. leis3                    rlxall - totwrk
%  13. smsa                     = 1 if live in smsa
%  14. lhrwage                  log hourly wage
%  15. lothinc                  log othinc, unless othinc < 0
%  16. male                     = 1 if male
%  17. marr                     = 1 if married
%  18. prot                     = 1 if Protestant
%  19. rlxall                   slpnaps + personal activs
%  20. selfe                    =1 if self employed
%  21. sleep                    mins sleep at night, per week
%  22. slpnaps                  mins sleep, including naps, per week
%  23. south                    =1 if live in south
%  24. spsepay                  spousal wage income
%  25. spwrk75                  =1 if spouse works
%  26. totwrk                   mins worked per week
%  27. union                    =1 if belong to union
%  28. worknrm                  mins work main job
%  29. workscnd                 mins work second job
%  30. exper                    age - educ - 6
%  31. yngkid                   =1 if children < 3 present
%  32. yrsmarr                  years married
%  33. hrwage                   hourly wage
%  34. agesq                    age^2

age     = data(:,1);
black   = data(:,2);
ccase   = data(:,3);
clerical= data(:,4);
construc= data(:,5);
educ    = data(:,6);
earns74 = data(:,7);
gdhlth  = data(:,8);
inlf    = data(:,9);
leis1   = data(:,10);
leis2   = data(:,11);
leis3   = data(:,12);
smsa    = data(:,13);
lhrwage = data(:,14);
lothinc = data(:,15);
male    = data(:,16);
marr    = data(:,17);
prot    = data(:,18);
rlxall  = data(:,19);
selfe   = data(:,20);
sleep   = data(:,21);
slpnaps = data(:,22);
south   = data(:,23);
spsepay = data(:,24);
spwrk75 = data(:,25);
totwrk  = data(:,26);
union   = data(:,27);
worknrm = data(:,28);
workscnd= data(:,29);
exper   = data(:,30);
yngkid  = data(:,31);
yrsmarr = data(:,32);
hrwage  = data(:,33);
agesq   = data(:,34);


yy = sleep;
XX = [ones(size(yy)) totwrk educ age age.^2 yngkid male];

res_sleep = ols(yy,XX);
vnames = strvcat('sleep', 'konst', 'towrk', 'educ', 'age', 'age^2', 'yngkid', 'male');
prt_reg(res_sleep,vnames)


u2 = res_sleep.resid.^2;
res_u2 = ols(u2,[ones(size(yy)) male]);
vnames = strvcat('u2', 'konst', 'male');
prt_reg(res_u2,vnames)




